package colruyt.sonarpocsvc.filter;

import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.slf4j.MDC;

import colruyt.coreutillib.system.PromotionLevel;

public class LoggingFilter implements Filter {

	@Override
	public void doFilter(ServletRequest request, ServletResponse response, FilterChain chain)
			throws IOException, ServletException {
	

		HttpServletRequest httpRequest = (HttpServletRequest) request;
		HttpServletResponse httpResponse = (HttpServletResponse) response;


		if (PromotionLevel.is(PromotionLevel.ontw)) {
			MDC.put("promotionLevel", "development");
		}

		MDC.put("user", httpRequest.getRemoteUser());

		String clientIP=httpRequest.getHeader("x-forwarded-for");
		clientIP=clientIP!=null?clientIP:httpRequest.getRemoteAddr();

		MDC.put("clientIP", clientIP);


		chain.doFilter(httpRequest, httpResponse);
		MDC.clear();

	}

	@Override
	public void destroy() {
		// TODO Auto-generated method stub

	}

	@Override
	public void init(FilterConfig filterConfig) throws ServletException {
		// TODO Auto-generated method stub

	}

}
