package colruyt.sonarpocsvc.resource;

import colruyt.sonarpocsvcejb.bo.MyBo;
import colruyt.sonarpocsvc.delegate.MyDelegate;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;

import javax.inject.Inject;
import javax.ejb.LocalBean;
import javax.ejb.Stateless;
import javax.ws.rs.*;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;
import java.util.List;

@Stateless
@LocalBean
@Api
@Path("v1/myresource")
public class MyResource {

    @Inject
    private MyDelegate myDelegate;

    @GET
    @Produces(MediaType.APPLICATION_JSON)
    @ApiOperation(value = "Search all values of My Resource for a single language.", notes = "", tags = { "My Resource", })
    public Response findAll(
            @ApiParam(value = "ISO language code in which the result has to be returned", example = "NL")
            @QueryParam("isoLangCode") String isoLangCode) {

        List<MyBo> functionalityBoList = myDelegate.findAll(isoLangCode);

        return Response.ok().type(MediaType.APPLICATION_JSON).entity(functionalityBoList).build();
    }

    @GET
    @Produces(MediaType.APPLICATION_JSON)
    @Path("/{myId}")
    @ApiOperation(value="Get the detail of My Resource.", notes = "",
                    response = MyBo.class, tags = { "My Resource", })
    public Response getFuntionalityDetail(
                @ApiParam(name = "myId", value="Id to search for", example = "309")
                @PathParam(value = "myId") String myId) {

        MyBo bo = new MyBo();
        bo.setId(myId);

        return Response.ok().type(MediaType.APPLICATION_JSON).entity(bo).build();
    }

}
